-- 1.Παρουσιάστε τα στοιχεία όλων των πινάκων.
select * from patient;
select * from doctor;
select * from medicine;
select * from treatment;
select * from prescription;

-- 2. Δείξτε ασθενείς που έχουν ΑΜΚΑ μικρότερο ή ίσο του 101050 και μεγαλύτερο ή ίσο του 101010.
select * from patient where pamka<=101050 or pamka>101010;
-- 3. Δείξτε ασθενείς που το όνομα τους είναι Νίκος ή Μαρία

-- 4. Δείξτε τα στοιχεία των συνταγών που έγραψε για τον ασθενή με ΑΜΚΑ 101010 ο γιατρός με ΑΦΜ 9990
select * 
from 
	patient,doctor,prescription
where 
	patient.PATIENT_ID=prescription.PATIENT_ID and
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    PAMKA='101010' and DAFM=9990;
-- 5. Δείξτε τα στοιχεία των συνταγών που έγραψε για τον ασθενή με ΑΜΚΑ 101010 ο γιατρός με ΑΦΜ 9990 για το χρονικό
-- διάστημα από 1/1/2016 έως 31/12/2018
select * 
from 
	patient,doctor,prescription
where 
	patient.PATIENT_ID=prescription.PATIENT_ID and
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    PAMKA='101010' and DAFM=9990 and ISSUE_DATE>='2016-01-01'; 
-- 6. Δείξτε το συνολικό ποσό των φαρμάκων που χορηγήθηκαν στον ασθενή με ΑΜΚΑ 101010 το 2016
select 
sum(med_cost) 
from 
	patient,treatment,prescription
where 
	patient.PATIENT_ID=prescription.PATIENT_ID and
    prescription.PRESCRIPTION_ID=treatment.PRESCRIPTION_ID and
    PAMKA='101010' and ISSUE_DATE>='2016-01-01' and ISSUE_DATE<'2017-01-01'; 
-- 7. Δείξτε τις συνταγές που συνταγογράφησε ο ιατρός με ΑΦΜ 8880 το 2016
select * 
from 
	patient,doctor,prescription
where 
	patient.PATIENT_ID=prescription.PATIENT_ID and
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    DAFM=8880 and ISSUE_DATE>='2016-01-01' AND ISSUE_DATE<='2016-12-31' ; 
-- 8. Δείξτε τις συνταγές στις οποίες ο ιατρός με ΑΦΜ 9990 συνταγογράφησε το φάρμακο Depon
select 
DOCTOR.DNAME,
PATIENT.PNAME,
PATIENT.PSURNAME,
ISSUE_DATE,
MED_NAME 
from 
	patient,doctor,prescription,treatment,medicine
where 
	patient.PATIENT_ID=prescription.PATIENT_ID and
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    prescription.PRESCRIPTION_ID=treatment.PRESCRIPTION_ID and
    treatment.MEDICINE_ID=medicine.MEDICINE_ID and
    DAFM=9990 and MED_NAME='DEPON' ; 
-- 9. Δείξτε τις συνταγές στις οποίες ο ιατρός με ΑΦΜ 9990 συνταγογράφησε το φάρμακο Depon ή το φάρμακο Aspirin

select 
	DOCTOR.DNAME,
    PATIENT.PNAME,
    PATIENT.PSURNAME,
    ISSUE_DATE,
    MED_NAME 
from 
	patient,doctor,prescription,treatment,medicine
where 
	patient.PATIENT_ID=prescription.PATIENT_ID and
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    prescription.PRESCRIPTION_ID=treatment.PRESCRIPTION_ID and
    treatment.MEDICINE_ID=medicine.MEDICINE_ID and
    DAFM=9990 and (MED_NAME='DEPON' OR MED_NAME='ASPIRIN') ; 
-- 10. Δείξτε τη συνολική δαπάνη για κάθε φάρμακο
select 
	MED_NAME ,
    SUM(med_cost)
    
from 
treatment,medicine
where 
	treatment.MEDICINE_ID=medicine.MEDICINE_ID 
    GROUP BY MED_NAME ;
-- 11. Δείξτε τη συνολική δαπάνη για κάθε φάρμακο ανά έτος
select 
	MED_NAME ,
     extract(year from prescription.issue_date) AS 'ΕΤΟΣ' ,
    SUM(med_cost)    
from 
treatment,medicine,PRESCRIPTION
where 
	treatment.MEDICINE_ID=medicine.MEDICINE_ID AND
    treatment.PRESCRIPTION_ID=prescription.PRESCRIPTION_ID
    GROUP BY MED_NAME, extract(year from prescription.issue_date) ;
-- 12. Δείξτε τον ιατρό με τους περισσότερους ασθενείς
with max_pats as (select 
					DOCTOR.DAFM,
                    count(distinct prescription.PATIENT_ID) count_pats
				from 
					doctor,prescription
				where 
                 prescription.DOCTOR_ID=doctor.DOCTOR_ID 
				group by DOCTOR.DAFM)
select 
	DOCTOR.DAFM,
    count(distinct prescription.PATIENT_ID)
from 
	doctor,prescription
where 
    prescription.DOCTOR_ID=doctor.DOCTOR_ID 
group by DOCTOR.DAFM having count(distinct prescription.PATIENT_ID)= (select max(count_pats) from max_pats) ; 
 

-- 13. Δείξτε τον ασθενή με τις λιγότερες συνταγές

select * from patient;
select * from doctor;
select * from medicine;
select * from treatment;
select * from prescription;



with pres_pat as (
select 
	patient.PAMKA,
    count(*) pres
from 
	patient,prescription
where 
    prescription.PATIENT_ID=patient.PATIENT_ID 
group by patient.PAMKA 
)
select 
	patient.PAMKA,
    count(*)
from 
	patient,prescription
where 
    prescription.PATIENT_ID=patient.PATIENT_ID 
group by patient.PAMKA having count(*) =(select min(pres) from pres_pat);

-- 14. Θα πρέπει να απαντήσετε σε ένα απο τα παρακάτω.
-- Δείξτε τον ιατρό που έχει MO συνταγών  > από τον
-- μέσο ορό της συνολικής δαπάνης συνταγών
-- 

-- STEP 1
-- δαπάνη συνταγών
select 
	DOCTOR.DAFM,
    avg(med_cost)
from 
	doctor,prescription,treatment
where 
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    treatment.PRESCRIPTION_ID=prescription.PRESCRIPTION_ID
group by DOCTOR.DAFM;

-- STEP 2
-- Μ.Ο. Συνολικής δαπάνης συνταγών = Συνολική Δαπάνη Συνταγών/ Πλήθος Συνταγών

select 
	DOCTOR.DAFM,
    doctor.DNAME,
    avg(med_cost)
from 
	doctor,prescription,treatment
where 
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    treatment.PRESCRIPTION_ID=prescription.PRESCRIPTION_ID
group by DOCTOR.DAFM
having avg(med_cost)>(
select 
	avg(med_cost)
from 
	doctor,prescription,treatment
where 
    prescription.DOCTOR_ID=doctor.DOCTOR_ID and
    treatment.PRESCRIPTION_ID=prescription.PRESCRIPTION_ID
);
